/*	$Id: ImageDecoder.h,v 1.1 2001/10/07 17:34:22 kent Exp $	-*- c++ -*- */
/*
 * Copyright 2001 TAMURA Kent
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __IMAGEDECODER_H__
#define __IMAGEDECODER_H__

#include "config.h"
#ifdef _WIN32
# include "susie.h"
#endif

class ImageDecoder {
public:
        virtual ~ImageDecoder() {
        }
        virtual bool initialize(const uint8_t* buffer, size_t size) = 0;
        virtual size_t getWidth() const = 0;
        virtual size_t getHeight() const = 0;
        virtual void decode(uint32_t* dst, size_t bytes_per_line) const = 0;
        virtual bool isAlpha() const = 0;
#ifdef _WIN32
        virtual void getInfo(SusiePictureInfo* pic) const = 0;
        virtual void getInfo(BITMAPINFOHEADER* bmih) const = 0;
#endif
};

#endif // __IMAGEDECODER_H__
