/*	$Id: Rqd.h,v 1.1 2001/10/07 18:23:11 kent Exp $	-*- c++ -*- */
/*
 * Copyright 2001 TAMURA Kent
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __RQD_H__
#define __RQD_H__

#include "ImageDecoder.h"

class Rqd: public ImageDecoder {
        uint16_t width, height; // Size of destination
        uint32_t size;          // The size of compressed data
        uint8_t* in;            // Compressed data

public:
        Rqd();
        virtual bool initialize(const uint8_t* buffer, size_t size);
        virtual ~Rqd();
        virtual size_t getWidth() const;
        virtual size_t getHeight() const;
        virtual void decode(uint32_t* dst, size_t bytes_per_line) const;
        virtual bool isAlpha() const {
                return true;
        }

#ifdef _WIN32
        virtual void getInfo(SusiePictureInfo* pic) const;
        virtual void getInfo(BITMAPINFOHEADER* bmih) const;
#endif
        static bool isSupported(const char* filename, const uint8_t* buffer, size_t size);
};

#endif // __RQD_H__


