
/*	$Id: config.h,v 1.3 2001/11/20 14:54:59 kent Exp $	*/
/*
 * Copyright 2001 TAMURA Kent
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __CONFIG_H__
#define __CONFIG_H__

#ifdef __GNUC__
# ifdef __MINGW32__
#  include <stdint.h>
   /* MinGW has only _vsnprintf() */
# elif defined(__NetBSD__)
#  include <inttypes>
#  define _vsnprintf	vsnprintf
# endif
# define _PACK_ATTR	__attribute__((packed))
# define _FUNCATTR1	__stdcall
# define _FUNCATTR2

#elif defined(__BORLANDC__)
  typedef int int32_t;
  typedef unsigned int uint32_t;
  typedef short int16_t;
  typedef unsigned short uint16_t;
  typedef signed char int8_t;
  typedef unsigned char uint8_t;
# include "malloc.h"
# define strcasecmp	stricmp
  /* BCC has both of vsnprintf() and _vsnprintf() */
# define _PACK_ATTR
# define _FUNCATTR1	__stdcall
# define _FUNCATTR2

#elif defined(_MSC_VER)
  typedef int int32_t;
  typedef unsigned int uint32_t;
  typedef short int16_t;
  typedef unsigned short uint16_t;
  typedef signed char int8_t;
  typedef unsigned char uint8_t;
  typedef int bool;
# define false	0
# define true	1
# include "malloc.h"
# define strcasecmp	stricmp
  /* VC++ has only _vsnprintf() */
# define _PACK_ATTR
# define _FUNCATTR1
# define _FUNCATTR2	__stdcall
#endif

#ifdef _WIN32
# define READ_BINARY "rb"
#else
# define READ_BINARY "r"
#endif

#endif /* __CONFIG_H__ */
