/*	$Id: espi.h,v 1.7 2001/10/07 17:13:51 kent Exp $	-*- c++ -*- */
/*
 * Copyright 2001 TAMURA Kent
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __ESPI_H__
#define __ESPI_H__
#include "susie.h"

/**
 * Œ񋟂 API ́ASusie Plug-in API ̂̏ꂵ̂IȂ
 * ̂łB̖邪AׂĂ̖
 * 킯ł͂ȂB
 *
 * GetPluginInfo()  ConfigurationDlg() ɑ̂͒`
 * ȂBSusie Plug-in API ̂̂̂܂܎gƂz肷B
 *
 *
 * EspiOpen*FromBuffer(): obt@̌^ const void* ̂ق
 * ȂB LocalLock() ̖߂l void* B
 */

typedef void* HSARCHIVE;
typedef void* HSPICTURE;

#ifdef ESPI_IMPLEMENTATION
# define ESPI_API __declspec(dllexport)
#else
# define ESPI_API __declspec(dllimport)
#endif

EXTERN_C ESPI_API int __stdcall
EspiIsSupportedFile(const char* filename, HANDLE fd);
EXTERN_C ESPI_API int __stdcall
EspiIsSupportedBuffer(const char* filename, const BYTE* buffer, size_t size);


EXTERN_C ESPI_API int __stdcall
EspiOpenArchiveFromFile(const char* filename, long offset, HSARCHIVE* phsa);

/**
 * ne EspiCloseArchive() ĂԂ܂ŕێĂƁB
 */
EXTERN_C ESPI_API int __stdcall
EspiOpenArchiveFromBuffer(const BYTE* buffer, size_t size, HSARCHIVE* phsa);

EXTERN_C ESPI_API int __stdcall
EspiCloseArchive(HSARCHIVE arc);

/**
 * w肵A[JĈׂẴt@C𓾂B
 * ʂƂē *phl ɂ̗vfĂ邩́A
 * LocalSize(*phl) / sizeof(SusieFileInfo) ŋ߂B
 * GetArchiveInfo() ̂悤ɗ]v1oCg 0 킯ł͂ȂB
 */
EXTERN_C ESPI_API int __stdcall
EspiGetArchiveInfo(HSARCHIVE arc, HLOCAL* phl);

/**
 * w肵A[JC̎w肵Õt@C̏𓾂B
 */
EXTERN_C ESPI_API int __stdcall
EspiGetFileInfo(HSARCHIVE arc, const char* filename, BOOL ignoreCase, SusieFileInfo* psfi);

/**
 * w肵A[JC̎w肵Õt@Ct@CɏoB
 */
EXTERN_C ESPI_API int __stdcall
EspiGetFileToFile(HSARCHIVE arc, const char* filename, BOOL ignoreCase, const char* destdir,
                  PROGRESSCALLBACK callback, long ldata);

/**
 * w肵A[JC̎w肵Õt@CɏoB
 */
EXTERN_C ESPI_API int __stdcall
EspiGetFileToBuffer(HSARCHIVE arc, const char* filename, BOOL ignoreCase, HLOCAL* phl,
                    PROGRESSCALLBACK callback, long ldata);



EXTERN_C ESPI_API int __stdcall
EspiOpenPictureFromFile(const char* filename, long offset, HSPICTURE* phsp);

/**
 * ne̓vOCŃRs[ĂB
 * Ăяo buffer ̓eɔjłB
 */
EXTERN_C ESPI_API int __stdcall
EspiOpenPictureFromBuffer(const BYTE* buffer, size_t size, HSPICTURE* phsp);

EXTERN_C ESPI_API int __stdcall
EspiClosePicture(HSPICTURE pic);

/**
 * w肵摜IuWFNg̏𓾂B
 * œ́AEspiGetPicture() œ DIB ̏ƈv
 * Kv͂ȂB
 *   Etop-down DIB ԂƂĂA摜̍͐̒l
 *   E24bpp DIB ԂƂĂA摜̂̂{Ă
 *      48bpp ȂAł 48bpp ƂԂB
 * ܂Au摜{ǂĂ邩vłA
 * ǂ DIB ɃfR[h邩͊֌WȂB
 */
EXTERN_C ESPI_API int __stdcall
EspiGetPictureInfo(HSPICTURE pic, SusiePictureInfo* pspi);

/**
 * w肵摜IuWFNg DIB 𓾂B
 * @param cap ĂяoAvP[Vǂ DIB 󂯎邩
 *            tOB0 (ESPI_CAP_NONE) ̏ꍇ Susie Plug-in API
 *             GetPicture() Ɠl̋(bottom-up ԂȂAȂ)
 */
EXTERN_C ESPI_API int __stdcall
EspiGetPicture(HSPICTURE pic, DWORD cap, HLOCAL* phbinfo, HLOCAL* phbm,
               PROGRESSCALLBACK callback, long ldata);
/**
 * kWJT|[gĂȂꍇ́A EspiGetPicture() 
 * 񂾂肹ASPI_ERROR_NOT_IMPLEMENTED ԂBtTCYƏk
 * TCY̗KvȃAvP[V̏ꍇ2xtTCYW
 * J邱Ƃ邽߁B
 */
EXTERN_C ESPI_API int __stdcall
EspiGetPreview(HSPICTURE pic, DWORD cap, HLOCAL* phbinfo, HLOCAL* phbm,
               PROGRESSCALLBACK callback, long ldata);

/*
 * EspiGetPicture()  cap p[^Ɏgl:
 *   (ꕔ̂̂́uBITMAPV4HEADER ɑΉvōςނA
 *    b₱Ȃ̂ BITMAPINFOHEADER ̂܂܂ɂ)
 */
#define ESPI_CAP_NONE	0
#define ESPI_CAP_TOPDOWN	0x01 /* BTIMAPINFOHEADER  biHeight ̒lɂȂ */
#define ESPI_CAP_32BPP		0x02 /* biBitCount  32AbiCompression  BI_RGB */
#define ESPI_CAP_ALPHA32	0x04 /* biBitCount  32AbiCompression  BI_BITFIELDA
                                      * bmiColors[0] == 0x0000ff, bmiColors[1] == 0x00ff00,
                                      * bmiColors[2] == 0xff0000, bmiColors[3] == 0xff000000
                                      * ɂȂ */
                                     /* At@`lf[^Ȃ̂Ȃf[^Ȃ̂
                                        AvP[Vł悤ɂĂ */
#define	ESPI_CAP_48BPP		0x08 /* biBitCount  48 ɂȂ */
#define ESPI_CAP_ALPHA64	0x10 /* biBitCount  64 ɂȂ */

/* For applications */
typedef _FUNCATTR1 int
(_FUNCATTR2 *ESPI_ISSUPPORTEDFILE)(const char* filename, HANDLE fd);
typedef _FUNCATTR1 int
(_FUNCATTR2 *ESPI_ISSUPPORTEDBUFFER)(const char* filename, const BYTE* buffer, size_t size);
typedef _FUNCATTR1 int
(_FUNCATTR2 *ESPI_OPENARCHIVEFROMFILE)(const char* filename, long offset, HSARCHIVE* phsa);
typedef _FUNCATTR1 int
(_FUNCATTR2 *ESPI_OPENARCHIVEFROMBUFFER)(const BYTE* buffer, size_t size, HSARCHIVE* phsa);
typedef _FUNCATTR1 int
(_FUNCATTR2 *ESPI_CLOSEARCHIVE)(HSARCHIVE arc);
typedef _FUNCATTR1 int
(_FUNCATTR2 *ESPI_GETARCHIVEINFO)(HSARCHIVE arc, HLOCAL* phl);
typedef _FUNCATTR1 int
(_FUNCATTR2 *ESPI_GETFILEINFO)(HSARCHIVE arc, const char* filename,
                               BOOL ignoreCase, SusieFileInfo* psfi);
typedef _FUNCATTR1 int
(_FUNCATTR2 *ESPI_GETFILETOFILE)(HSARCHIVE arc, const char* filename,
                                 BOOL ignoreCase, const char* destdir,
                                 PROGRESSCALLBACK callback, long ldata);
typedef _FUNCATTR1 int
(_FUNCATTR2 *ESPI_GETFILETOBUFFER)(HSARCHIVE arc, const char* filename,
                                   BOOL ignoreCase, HLOCAL* phl,
                                   PROGRESSCALLBACK callback, long ldata);
typedef _FUNCATTR1 int
(_FUNCATTR2 *ESPI_OPENPICTUREFROMFILE)(const char* filename, long offset, HSPICTURE* phsp);
typedef _FUNCATTR1 int
(_FUNCATTR2 *ESPI_OPENPICTUREFROMBUFFER)(const BYTE* buffer, size_t size, HSPICTURE* phsp);
typedef _FUNCATTR1 int
(_FUNCATTR2 *ESPI_CLOSEPICTURE)(HSPICTURE pic);
typedef _FUNCATTR1 int
(_FUNCATTR2 *ESPI_GETPICTUREINFO)(HSPICTURE pic, SusiePictureInfo* pspi);
typedef _FUNCATTR1 int
(_FUNCATTR2 *ESPI_GETPICTURE)(HSPICTURE pic, DWORD cap, HLOCAL* phbinfo, HLOCAL* phbm,
                              PROGRESSCALLBACK callback, long ldata);
typedef _FUNCATTR1 int
(_FUNCATTR2 *ESPI_GETPREVIEW)(HSPICTURE pic, DWORD cap, HLOCAL* phbinfo, HLOCAL* phbm,
                              PROGRESSCALLBACK callback, long ldata);


#endif /* __ESPI_H__ */
