/*	$Id: susie.h,v 1.6 2001/10/07 09:28:58 kent Exp $	-*- c++ -*- */
/*
 * Copyright 2001 TAMURA Kent
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __SUSIE_H__
#define __SUSIE_H__

#include <windows.h>
#include <time.h>
#include "config.h"

typedef struct {
        unsigned char method[8];
        unsigned long position;
        unsigned long compsize;
        unsigned long filesize;
        time_t timestamp;
        char path[200];
        char filename[200];
        unsigned long crc;
} SusieFileInfo;

#ifdef __BORLANDC__
# pragma option -a-
#endif
#ifdef _MSC_VER
# include <pshpack1.h>
#endif
typedef struct {
        long left;
        long top;
        long width;
        long height;
        WORD x_density;
        WORD y_density;
        short colorDepth;
        HLOCAL hInfo;
} _PACK_ATTR SusiePictureInfo;
#ifdef __BORLANDC__
# pragma option -a.
#endif
#ifdef _MSC_VER
# include <poppack.h>
#endif


#define SPI_SOURCE_FILE		0
#define SPI_SOURCE_MEMORY	1
#define SPI_IGNORE_CASE		0x80
#define SPI_DEST_FILE		0x000
#define SPI_DEST_MEMORY		0x100
#define SPI_IS_SOURCE_FILE(fl)		(((fl) & 7) == 0)
#define SPI_IS_SOURCE_MEMORY(fl)	(((fl) & 7) == 1)
#define SPI_IS_IGNORE_CASE(fl)		(((fl) & 0x80) == 0x80)
#define SPI_IS_DEST_FILE(fl)		(((fl) & 0x0700) == 0x000)
#define SPI_IS_DEST_MEMORY(fl)		(((fl) & 0x0700) == 0x100)

#define SPI_CONF_ABOUT	0
#define SPI_CONF_CONF	1

#define SPI_ERROR_NOT_IMPLEMENTED	(-1)
#define SPI_ERROR_SUCCESS		0
#define SPI_ERROR_CALLBACK_ABORT	1
#define SPI_ERROR_UNKNOWN_FORMAT	2
#define SPI_ERROR_BROKEN_DATA		3
#define SPI_ERROR_NO_MEMORY		4
#define SPI_ERROR_MEMORY		5
#define SPI_ERROR_READ			6
#define SPI_ERROR_RESERVED		7
#define SPI_ERROR_INTERNAL		8			

typedef int _FUNCATTR1 (_FUNCATTR2 *PROGRESSCALLBACK)(int count, int endCount, long context);

/* For applications */
typedef int _FUNCATTR1 (_FUNCATTR2 *SPI_GETPLUGININFO)(int infono, LPSTR buf, int buflen);
typedef int _FUNCATTR1 (_FUNCATTR2 *SPI_ISSUPPORTED)(LPCSTR filename, DWORD dw);
typedef int _FUNCATTR1 (_FUNCATTR2 *SPI_GETPICTUREINFO)(LPCSTR buf, long len, unsigned int flag,
                                                        SusiePictureInfo* lpInfo);
typedef int _FUNCATTR1 (_FUNCATTR2 *SPI_GETPICTURE)(LPCSTR buf, long len, unsigned int flag,
                                                    HLOCAL* pHBInfo, HLOCAL* pHBm,
                                                    PROGRESSCALLBACK callback, long lData);
typedef int _FUNCATTR1 (_FUNCATTR2 *SPI_CONFIGURATIONDLG)(HWND parent, int fnc);
typedef int _FUNCATTR1 (_FUNCATTR2 *SPI_GETARCHIVEINFO)(LPCSTR buf, long len,
                                                        unsigned int flag, HLOCAL* lphInf);
typedef int _FUNCATTR1 (_FUNCATTR2 *SPI_GETFILEINFO)(LPCSTR buf, long len, LPCSTR filename,
                                                     unsigned int flag, SusieFileInfo* lpInfo);
typedef int _FUNCATTR1 (_FUNCATTR2 *SPI_GETFILE)(LPCSTR buf, long len, LPCSTR dest, unsigned int flag,
                                                 PROGRESSCALLBACK callback, long lData);

#define BMP_BYTE_WIDTH(w, bpp) ((((w)*(bpp)+31)/32)*4)

#endif /* __SUSIE_H__ */
